Attribute VB_Name = "ApiDecs"
'Cryptografic-API-Deklarationen
Public Declare Function CryptAcquireContext Lib "advapi32.dll" Alias "CryptAcquireContextA" (phProv As Long, pszContainer As String, pszProvider As String, ByVal dwProvType As Long, ByVal dwFlags As Long) As Long
Public Declare Function CryptCreateHash Lib "advapi32.dll" (ByVal hProv As Long, ByVal Algid As Long, ByVal hKey As Long, ByVal dwFlags As Long, phHash As Long) As Long
Public Declare Function CryptDeriveKey Lib "advapi32.dll" (ByVal hProv As Long, ByVal Algid As Long, ByVal hBaseData As Long, ByVal dwFlags As Long, phKey As Long) As Long
Public Declare Function CryptDestroyHash Lib "advapi32.dll" (ByVal hHash As Long) As Long
Public Declare Function CryptDestroyKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Declare Function CryptEncrypt Lib "advapi32.dll" (ByVal hKey As Long, ByVal hHash As Long, ByVal Final As Long, ByVal dwFlags As Long, ByVal pbData As String, pdwDataLen As Long, ByVal dwBufLen As Long) As Long
Public Declare Function CryptDecrypt Lib "advapi32.dll" (ByVal hKey As Long, ByVal hHash As Long, ByVal Final As Long, ByVal dwFlags As Long, ByVal pbData As String, pdwDataLen As Long) As Long
Public Declare Function CryptExportKey Lib "advapi32.dll" (ByVal hKey As Long, ByVal hExpKey As Long, ByVal dwBlobType As Long, ByVal dwFlags As Long, ByVal pbData As String, pdwDataLen As Long) As Long
Public Declare Function CryptImportKey Lib "advapi32.dll" (ByVal hKey As Long, ByVal pbData As String, ByVal dwDataLen As Long, ByVal hImpKey As Long, ByVal dwFlags As Long, ByVal phKey As Long) As Long
Public Declare Function CryptGenKey Lib "advapi32.dll" (ByVal hProv As Long, ByVal Algid As Long, ByVal dwFlags As Long, phKey As Long) As Long
Public Declare Function CryptGetProvParam Lib "advapi32.dll" (ByVal hProv As Long, ByVal dwParam As Long, pbData As Any, pdwDataLen As Long, ByVal dwFlags As Long) As Long
Public Declare Function CryptGetUserKey Lib "advapi32.dll" (ByVal hProv As Long, ByVal dwKeySpec As Long, phUserKey As Long) As Long
Public Declare Function CryptHashData Lib "advapi32.dll" (ByVal hHash As Long, ByVal pbData As String, ByVal dwDataLen As Long, ByVal dwFlags As Long) As Long
Public Declare Function CryptReleaseContext Lib "advapi32.dll" (ByVal hProv As Long, ByVal dwFlags As Long) As Long
Public Declare Function CryptSignHashA Lib "advapi32.dll" (ByVal hHash As Long, ByVal dwKeySpec As Long, ByVal sDescription As String, ByVal dwFlags As Long, ByVal pbSignature As String, pdwSigLen As Long) As Long
Public Declare Function CryptVerifySignatureA Lib "advapi32.dll" (ByVal hHash As Long, ByVal pbSignature As String, ByVal dwSigLen As Long, ByVal hPubKey As Long, ByVal sDescription As String, ByVal dwFlags As Long) As Long

'Konstanten, IDs, Flags
Public Const MS_DEF_PROV = "Microsoft Base Cryptographic Provider v1.0" & vbNullChar
Public Const PROV_RSA_FULL = 1
Public Const CRYPT_NEWKEYSET = &H8
Public Const PP_CONTAINER = 6
Public Const AT_KEYEXCHANGE = 1
Public Const AT_SIGNATURE = 2

'Algorithm classes
Public Const ALG_CLASS_ANY = 0
Public Const ALG_CLASS_SIGNATURE = 8192        '1 shl 13
Public Const ALG_CLASS_MSG_ENCRYPT = 16384     '2 shl 13
Public Const ALG_CLASS_DATA_ENCRYPT = 24576    '3 shl 13
Public Const ALG_CLASS_HASH = 32768            '4 shl 13
Public Const ALG_CLASS_KEY_EXCHANGE = 40960    '5 shl 13
'Algorithm types
Public Const ALG_TYPE_ANY = 0
Public Const ALG_TYPE_DSS = 512                '1 shl 9
Public Const ALG_TYPE_RSA = 1024               '2 shl 9
Public Const ALG_TYPE_BLOCK = 1536             '3 shl 9
Public Const ALG_TYPE_STREAM = 2048            '4 shl 9
'Generic sub-ids
Public Const ALG_SID_ANY = 0
'RSA sub-ids
Public Const ALG_SID_RSA_ANY = 0
Public Const ALG_SID_RSA_PKCS = 1
Public Const ALG_SID_RSA_MSATWORK = 2
Public Const ALG_SID_RSA_ENTRUST = 3
Public Const ALG_SID_RSA_PGP = 4
'DSS sub-ids
Public Const ALG_SID_DSS_ANY = 0
Public Const ALG_SID_DSS_PKCS = 1
Public Const ALG_SID_DSS_DMS = 2
'Block cipher sub ids
Public Const ALG_SID_DES = 1
'RC2 sub-ids
Public Const ALG_SID_RC2 = 2
'Stream cipher sub-ids
Public Const ALG_SID_RC4 = 1
Public Const ALG_SID_SEAL = 2
'Hash sub ids
Public Const ALG_SID_MD2 = 1
Public Const ALG_SID_MD4 = 2
Public Const ALG_SID_MD5 = 3
Public Const ALG_SID_SHA = 4
Public Const ALG_SID_MAC = 5
'algorithm identifier definitions
Public Const CALG_MD2 = ((ALG_CLASS_HASH Or ALG_TYPE_ANY) Or ALG_SID_MD2)
Public Const CALG_MD4 = ((ALG_CLASS_HASH Or ALG_TYPE_ANY) Or ALG_SID_MD4)
Public Const CALG_MD5 = ((ALG_CLASS_HASH Or ALG_TYPE_ANY) Or ALG_SID_MD5)
Public Const CALG_SHA = ((ALG_CLASS_HASH Or ALG_TYPE_ANY) Or ALG_SID_SHA)
Public Const CALG_MAC = ((ALG_CLASS_HASH Or ALG_TYPE_ANY) Or ALG_SID_MAC)
Public Const CALG_RSA_SIGN = ((ALG_CLASS_SIGNATURE Or ALG_TYPE_RSA) Or ALG_SID_RSA_ANY)
Public Const CALG_DSS_SIGN = ((ALG_CLASS_SIGNATURE Or ALG_TYPE_DSS) Or ALG_SID_DSS_ANY)
Public Const CALG_RSA_KEYX = ((ALG_CLASS_KEY_EXCHANGE Or ALG_TYPE_RSA) Or ALG_SID_RSA_ANY)
Public Const CALG_DES = ((ALG_CLASS_DATA_ENCRYPT Or ALG_TYPE_BLOCK) Or ALG_SID_DES)
Public Const CALG_RC2 = ((ALG_CLASS_DATA_ENCRYPT Or ALG_TYPE_BLOCK) Or ALG_SID_RC2)
Public Const CALG_RC4 = ((ALG_CLASS_DATA_ENCRYPT Or ALG_TYPE_STREAM) Or ALG_SID_RC4)
Public Const CALG_SEAL = ((ALG_CLASS_DATA_ENCRYPT Or ALG_TYPE_STREAM) Or ALG_SID_SEAL)

#If USE_BLOCK_CIPHER = True Then
    'RC2 block cipher
    Public Const ENCRYPT_ALGORITHM = CALG_RC2
    Public Const ENCRYPT_BLOCK_SIZE = 8
#Else
    'defines for RC4 stream cipher
    Public Const ENCRYPT_ALGORITHM = CALG_RC4
    Public Const ENCRYPT_BLOCK_SIZE = 1
#End If

Public Const CRYPT_EXPORTABLE = 1
Private Const SIMPLEBLOB = 1

'Versionsabfrage
Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Declare Function GetUserName Lib "advapi32.dll" Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Declare Function GetComputerName Lib "kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long

Type OSVERSIONINFO
  dwOSVersionInfoSize As Long
  dwMajorVersion As Long
  dwMinorVersion As Long
  dwBuildNumber As Long
  dwPlatformId As Long
  szCSDVersion As String * 128
End Type

Public Const VER_PLATFORM_WIN32_NT = 2
Public Const VER_PLATFORM_WIN32_WINDOWS = 1
Public Const VER_PLATFORM_WIN32s = 0

'Bitverschiebung Shift Left/Right
Function Shl(Zahl%, Bits%) As Long
  Shl = Zahl% * (2 ^ Bits%)
End Function

Function Shr(Zahl%, Bits%) As Long
  Shr = Zahl% \ (2 ^ Bits%)
End Function

Function CryptGetHandle() As Long
  'Kennung fr Crypt Service Provider (CSP) ermitteln
  Container$ = vbNullChar
  Provider$ = MS_DEF_PROV & vbNullChar
  Dummy& = CryptAcquireContext(hCryptProv&, ByVal Container$, ByVal Provider$, PROV_RSA_FULL, 0)
  If hCryptProv& = 0 Then
    'Standardcontainer anlegen
    Dummy& = CryptAcquireContext(hCryptProv&, ByVal Container$, ByVal Provider$, PROV_RSA_FULL, CRYPT_NEWKEYSET)
  End If
  CryptGetHandle = hCryptProv&
End Function

Function CryptGetHash(hCrypt&, Algorythm%) As Long
  'Kennung Hash ermitteln
  Select Case Algorythm%
    Case 1
      ALG_ID& = CALG_MD2
      hKey& = 0
    Case 2
      ALG_ID& = CALG_MD5
      hKey& = 0
    Case 3
      ALG_ID& = CALG_SHA
      hKey& = 0
  End Select
  Dummy& = CryptCreateHash(hCrypt&, ALG_ID&, hKey&, 0, hHash&)
  CryptGetHash = hHash&
End Function

Sub CryptSetPassword(hHash&, Password$)
  'Kennwortbernahme
  Dummy& = CryptHashData(hHash&, Password$, Len(Password$), 0)
End Sub

Function CryptGetSession(hCrypt&, hHash&, Alg&) As Long
  'Sitzungskennung ermitteln
  Dummy& = CryptDeriveKey(hCrypt&, Alg&, hHash&, 0, sKey&)
  CryptGetSession = sKey&
End Function

Sub CryptReleaseHandle(hCrypt&)
  Dummy& = CryptDestroyKey&(hCrypt&)
End Sub

Sub CryptReleaseHash(hHash&)
  'Hash-Kennung freeigeben
  Dummy& = CryptDestroyHash(hHash&)
End Sub

Sub CryptReleaseSession(hCrypt&)
  'CSP-Freigabe (Aufruf, nachdem Handle freigegeben wurde)
  Dummy& = CryptReleaseContext(hCrypt&, 0)
End Sub

Function Crypt$(Algorythm%, AlgMode&, Information$, Password$)
  'Verschlsselung
  'Kennung Standard-CSP ermitteln
  hCrypt& = CryptGetHandle()
  'erfolgreich?
  If hCrypt& <> 0 Then
    'Hash-Kennung ermitteln
    hHash& = CryptGetHash(hCrypt&, Algorythm%)
    'erfolgreich?
    If hHash& <> 0 Then
      'evtl. Kennwort bernehmen
      CryptSetPassword hHash&, Password$
      'Sitzungskennung ermitteln
      sHandle& = CryptGetSession(hCrypt&, hHash&, AlgMode&)
      'Pufferspeicher fr Ergebnis aufbereiten
      iLen& = Len(Information$)
      bLen& = iLen& * 2
      Buffer$ = String$(bLen&, vbNullChar)
      LSet Buffer$ = Information$
      'Verschlsselung durchfhren
      Dummy& = CryptEncrypt(sHandle&, 0, 1, 0, Buffer$, iLen&, bLen&)
      'Hash-Kennung freigeben
      CryptReleaseHash hHash&
      'Ergebnis zurckliefern
      Crypt$ = Left$(Buffer$, iLen&)
    End If
    'Kennungen und Sitzung freigeben
    CryptReleaseHandle sHandle&
    CryptReleaseHandle hCrypt&
    CryptReleaseSession hCrypt&
  End If
End Function

Function DeCrypt$(Algorythm%, AlgMode&, Information$, Password$)
  'Entschlsselung
  'Kennung Standard-CSP ermitteln
  hCrypt& = CryptGetHandle()
  'erfolgreich?
  If hCrypt& <> 0 Then
    'Hash-Kennung ermitteln
    hHash& = CryptGetHash(hCrypt&, Algorythm%)
    'erfolgreich?
    If hHash& <> 0 Then
      'evtl. Kennwort bernehmen
      CryptSetPassword hHash&, Password$
      'Sitzungskennung ermitteln
      sHandle& = CryptGetSession(hCrypt&, hHash&, AlgMode&)
      'Pufferspeicher fr Ergebnis aufbereiten
      bLen& = Len(Information$)
      Buffer$ = String$(bLen&, vbNullChar)
      LSet Buffer$ = Information$
      'Entschlsselung durchfhren
      Dummy& = CryptDecrypt(sHandle&, 0, 1, 0, Buffer$, bLen&)
      'Hash-Kennung freigeben
      CryptReleaseHash hHash&
      'Ergebnis zurckliefern
      DeCrypt$ = Left$(Buffer$, bLen&)
    End If
    'Kennungen und Sitzung freigeben
    CryptReleaseHandle sHandle&
    CryptReleaseHandle hCrypt&
    CryptReleaseSession hCrypt&
  End If
End Function

Sub CryptFile(QuellDatei$, ZielDatei$, Password$)
  'Datei verschlsseln
  On Error Resume Next
  If FileExist(QuellDatei$) And Not FileExist(ZielDatei$) Then
      'Pufferspeicher maximal
      GesamtLen& = FileLen(QuellDatei$)
      If GesamtLen& > 30000 Then
          MaxBuffer$ = Space$(30000)
        Else
          MaxBuffer$ = Space$(GesamtLen&)
      End If
      DNr = FreeFile
      Open QuellDatei$ For Binary As #DNr
      Open ZielDatei$ For Binary As #DNr + 1
      'CSP-Kennung ermitteln
      hCrypt& = CryptGetHandle()
      'Zufallsschlssel generieren (hier fester Algorithmus)
      Dummy& = CryptGenKey(hCrypt&, CALG_RC4, CRYPT_EXPORTABLE, hKey&)
      Dummy& = CryptGetUserKey(hCrypt&, AT_KEYEXCHANGE, xKey&)
      Dummy& = CryptExportKey(hKey&, xKey&, SIMPLEBLOB, 0, vbNullString, BlobLen&)
      BlobBuffer$ = Space$(BlobLen&) & vbNullChar
      Dummy& = CryptExportKey(hKey&, xKey&, SIMPLEBLOB, 0, ByVal BlobBuffer$, BlobLen&)
      CryptDestroyKey xKey&
      'Header in verschlsselte Datei schreiben
      'Kennungsmerkmal
      Put #DNr + 1, , "IngES_CRYPT"
      'Lnge
      Put #DNr + 1, , BlobLen&
      'Inhalt (ohne ASCIIZ)
      Put #DNr + 1, , Left$(BlobBuffer$, BlobLen&)
      'Hash-Kennung ermitteln
      Dummy& = CryptCreateHash(hCrypt&, CALG_MD5, 0, 0, hHash&)
      'Kennwort bernehmen
      CryptSetPassword hHash&, Password$
      'Sitzungskennung ermitteln
      sHandle& = CryptGetSession(hCrypt&, hHash&, CALG_RC4)
      While Not (EOF(DNr)) And MaxBuffer$ <> ""
        Get #DNr, , MaxBuffer$
        iLen& = Len(MaxBuffer$)
        bLen& = iLen& * 2
        Buffer$ = String$(bLen&, vbNullChar)
        LSet Buffer$ = MaxBuffer$
        Dummy& = CryptEncrypt(sHandle&, 0, 1, 0, Buffer$, iLen&, bLen&)
        Put #DNr + 1, , iLen&
        Put #DNr + 1, , Left$(Buffer$, iLen&)
        GesamtLen& = GesamtLen& - Len(MaxBuffer$)
        If GesamtLen& > 30000 Then
            MaxBuffer$ = Space$(30000)
          Else
            MaxBuffer$ = Space$(GesamtLen&)
        End If
      Wend
      'Dateien schlieen
      Close #DNr
      Close #DNr + 1
      CryptReleaseHash hHash&
      CryptDestroyKey hKey&
      CryptDestroyKey xKey&
      CryptReleaseSession hCrypt&
    ElseIf FileExist(ZielDatei$) Then
      M$ = "Whlen Sie einen neuen Zieldateinamen oder lschen Sie die bereits existierende Zieldatei!"
      MsgBox M$, vbExclamation, "Zieldatei bereits vorhanden"
    Else
      M$ = "Whlen Sie eine andere zu verschlsselnde Datei an!"
      MsgBox M$, vbExclamation, "Quelldatei nicht vorhanden"
  End If
End Sub

Sub DeCryptFile(QuellDatei$, ZielDatei$, Password$)
  'Datei entschlsseln
  On Error Resume Next
  If FileExist(QuellDatei$) And Not FileExist(ZielDatei$) Then
      DNr = FreeFile
      Open QuellDatei$ For Binary As #DNr
      Open ZielDatei$ For Binary As #DNr + 1
      'CSP-Kennung ermitteln
      hCrypt& = CryptGetHandle()
      'Schlssel aus Datei lesen
      Kennung$ = Space$(11)
      Get #DNr, , Kennung$
      'benutzerdefinierte Kennung weist die Datei als verschlsselt aus!
      If Kennung$ = "IngES_CRYPT" Then
          'Schlssellnge (Blob)
          Get #DNr, , BlobLen&
          'Blob
          BlobBuffer$ = Space$(BlobLen&)
          Get #DNr, , BlobBuffer$
          'Schlssel fr Entschlsselung in CSP importieren
          Dummy& = CryptImportKey(hCrypt&, ByVal BlobBuffer$, BlobLen&, 0, 0, hKey&)
          'Hash-Kennung ermitteln
          Dummy& = CryptCreateHash(hCrypt&, CALG_MD5, 0, 0, hHash&)
          'Kennwort bernehmen
          CryptSetPassword hHash&, Password$
          'Sitzungskennung ermitteln
          sHandle& = CryptGetSession(hCrypt&, hHash&, CALG_RC4)
          While Not EOF(DNr)
            'Blocklnge
            Get #DNr, , iLen&
            'Pufferspeicher reservieren
            cInfo$ = Space$(iLen&)
            'verschlsselte Info lesen
            Get #DNr, , cInfo$
            bLen& = Len(cInfo$)
            Buffer$ = String$(bLen&, vbNullChar)
            LSet Buffer$ = cInfo$
            'Entschlsselung durchfhren
            Dummy& = CryptDecrypt(sHandle&, 0, 1, 0, Buffer$, bLen&)
            Put #DNr + 1, , Left$(Buffer$, bLen&)
          Wend
        Else
          'Entschlsselung ist nur bei vorhandener Kennung zulssig
          T$ = "Unbekanntes Dateiformat"
          M$ = "Die angewhlte Datei wurde nicht mit diesem Programm "
          M$ = "verschlsselt oder aber es handelt sich um keine verschlsselte Datei!"
          MsgBox M$, vbExclamation, T$
      End If
      'Dateien schlieen
      Close #DNr
      Close #DNr + 1
      CryptReleaseHash hHash&
      CryptDestroyKey hKey&
      CryptDestroyKey xKey&
      CryptReleaseSession hCrypt&
    ElseIf FileExist(ZielDatei$) Then
      M$ = "Whlen Sie einen neuen Zieldateinamen oder lschen Sie die bereits existierende Zieldatei!"
      MsgBox M$, vbExclamation, "Zieldatei bereits vorhanden"
    Else
      M$ = "Whlen Sie eine andere zu entschlsselnde Datei an!"
      MsgBox M$, vbExclamation, "Quelldatei nicht vorhanden"
  End If
End Sub

Function FileExist(Datei$) As Boolean
  'Datei auf Existenz prfen
  On Error Resume Next
  FileExist = (Dir(Datei$) <> "")
End Function

Sub Main()
  'dummy
End Sub
