VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cCrypt"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'Klassenmodul mit universell nutbaren
'Ver- und Entschlsselungsroutinen
'(Methoden werden auf die entsprechenden Funktionen und
'Unterprogramme des Moduls APIDECS.BAS umgeleitet)

Function Encryption(Algorythm%, AlgMode&, Information$, Password$) As String
  'Zeichenketten verschlsseln
  Encryption = Crypt$(Algorythm%, AlgMode&, Information$, Password$)
End Function

Function Decryption(Algorythm%, AlgMode&, Information$, Password$) As String
  'Zeichenketten entschlsseln
  Decryption = DeCrypt$(Algorythm%, AlgMode&, Information$, Password$)
End Function

Sub FileEncryption(QuellDatei$, ZielDatei$, Password$)
  'Datei verschlsseln
  CryptFile QuellDatei$, ZielDatei$, Password$
End Sub

Sub FileDecryption(QuellDatei$, ZielDatei$, Password$)
  'Datei verschlsseln
  DeCryptFile QuellDatei$, ZielDatei$, Password$
End Sub

Function CALG_RC2() As Long
  'Fkt.liefert Wert der gleichnamigen Konstanten zurck
  CALG_RC2 = ((ALG_CLASS_DATA_ENCRYPT Or ALG_TYPE_BLOCK) Or ALG_SID_RC2)
End Function

Function CALG_RC4() As Long
  'Fkt.liefert Wert der gleichnamigen Konstanten zurck
  CALG_RC4 = ((ALG_CLASS_DATA_ENCRYPT Or ALG_TYPE_STREAM) Or ALG_SID_RC4)
End Function

Function CALG_MD2() As Long
  'Fkt.liefert Wert der gleichnamigen Konstanten zurck
  CALG_MD2 = ((ALG_CLASS_HASH Or ALG_TYPE_ANY) Or ALG_SID_MD2)
End Function
  
Function CALG_MD5() As Long
  'Fkt.liefert Wert der gleichnamigen Konstanten zurck
  CALG_MD5 = ((ALG_CLASS_HASH Or ALG_TYPE_ANY) Or ALG_SID_MD5)
End Function
  
Function CALG_SHA() As Long
  'Fkt.liefert Wert der gleichnamigen Konstanten zurck
  CALG_SHA = ((ALG_CLASS_HASH Or ALG_TYPE_ANY) Or ALG_SID_SHA)
End Function

Function CanCrypt() As Boolean
  'Ermitteln, ob das System Cryptologie-Funktionen bereitstellt
  Dim vInfo As OSVERSIONINFO
  vInfo.dwOSVersionInfoSize = Len(vInfo)
  If GetVersionEx(vInfo) <> 0 Then
    'Platform
    Select Case vInfo.dwPlatformId
      Case VER_PLATFORM_WIN32_NT
        Platform$ = "Windows NT"
      Case VER_PLATFORM_WIN32_WINDOWS
        Platform$ = "Windows 95"
      Case VER_PLATFORM_WIN32s
        CanCrypt = False
        Exit Function
    End Select
    'Zusatzinfos (hier B-Zusatz von W95 enthalten)
    Info$ = vInfo.szCSDVersion + " "
    'Haupt-/Nebenversion
    Major& = vInfo.dwMajorVersion
    Minor& = vInfo.dwMinorVersion
    'Build
    If vInfo.dwPlatformId = VER_PLATFORM_WIN32_NT Then
        'Windows NT
        B& = vInfo.dwBuildNumber
        'NT-Bestandteil seit der Version 4.0
        If Major& >= 4 Then
          CanCrypt = True
          Exit Function
        End If
      Else
        'Windows 95: LowWord
        B& = vInfo.dwBuildNumber And &HFFFF&
    End If
    'Windows erfordert 4.00.950B (liefert intern als Revisionsnummer einen Wert grer 950 zurck!)
    If (Major& > 4) Or (Major& = 4 And Minor& > 0) Or (Major& = 4 And Minor& = 0 And B& > 950) Then
        CanCrypt = True
      Else
        CanCrypt = False
    End If
  End If
End Function
